/**
 * For copyright see license.txt.
 */
package anasy.examples.kalq1;

import anasy.SyntaxError;
import anasy.Token;
import anasy.input.ReadlineInput;
import anasy.syntax.special.Start;


public class Kalq1i extends Kalq1 {

	public static void main(String[] args) throws SyntaxError {
		System.out.println("Kalq 1 - calculator interactive interpreter");
		final ReadlineInput in = new ReadlineInput();
		Start start = new Start(in, Parser1.expr()) {
			@Override
			public void ensure() throws SyntaxError {
				if (lexer.peek(tokBegin)) {
					in.refeed();			
				} else if (lexer.peek(tokEnd)) {
					in.refeed();
					lexer.advanceNext();
				}
			}
		};
		while (in.ready()) {
			try {
				in.reset("");
				Token result = start.parse();
				if (result == null) continue;
				System.out.println(result);
			} catch (SyntaxError e) {
				System.out.println(e);
				continue;
			}
		}
	}

}
