package anasy.examples.kalq1;

import anasy.Node;
import anasy.Tokind;
import anasy.syntax.literals.RealNum;
import anasy.syntax.operators.Infix;
import anasy.syntax.operators.Outfix;
import anasy.syntax.operators.Postfix;
import anasy.syntax.operators.Prefix;
import anasy.syntax.operators.PrefixInfix;
import anasy.syntax.special.Expression;
import anasy.syntax.whitespace.InlineComment;
import anasy.syntax.whitespace.Whitespace;


class Num implements Node {

	public final double value;

	public Num(double value) {
		this.value = value;
	}

	@Override
	public String toString() {
		return Double.toString(value);
	}

}


public class Parser1 {

	static private Node n(double value) {
		return new Num(value);
	}

	static private double n2d(Node node) {
		if (node instanceof Num)
			return ((Num)node).value;
		return 0; //!!!
	}

	protected static Tokind expr() {
		return new Expression("<expr>",
			new Whitespace(),
			new InlineComment(";;"),
			new RealNum() {
				@Override
				protected Node makeNode(String lexeme) {
					return n(Double.parseDouble(lexeme));
				}
			},
			new Outfix("(", ")", 0),
			new Infix("==", 40) {
				@Override
				protected Node makeInfixNode(Node left, Node right) {
					return n2d(left) == n2d(right) ? n(1.0) : n(0.0);
				}		
			},
			new Infix("!=", 40) {
				@Override
				protected Node makeInfixNode(Node left, Node right) {
					return n2d(left) != n2d(right) ? n(1.0) : n(0.0);
				}
			},
			new Infix("<=", 40) {
				@Override
				public Node makeInfixNode(Node left, Node right) {
					return n2d(left) <= n2d(right) ? n(1.0) : n(0.0);
				}					
			},
			new Infix("<", 40) {
				@Override
				public Node makeInfixNode(Node left, Node right) {
					return n2d(left) < n2d(right) ? n(1.0) : n(0.0);
				}			
			},
			new Infix(">=", 40) {
				@Override
				public Node makeInfixNode(Node left, Node right) {
					return n2d(left) >= n2d(right) ? n(1.0) : n(0.0);
				}		
			},
			new Infix(">", 40) {
				@Override
				public Node makeInfixNode(Node left, Node right) {
					return n2d(left) > n2d(right) ? n(1.0) : n(0.0);
				}
			},
			new PrefixInfix("+", 100, 50) {
				@Override
				public Node makePrefixNode(Node operand) {
					return operand;
				}
				@Override
				public Node makeInfixNode(Node left, Node right) {
					return n(n2d(left) + n2d(right));
				}
			},
			new PrefixInfix("-", 100, 50) {
				@Override
				public Node makePrefixNode(Node operand) {
					return n(-n2d(operand));
				}
				@Override
				public Node makeInfixNode(Node left, Node right) {
					return n(n2d(left) - n2d(right));
				}
			},
			new Infix("*", 60) {
				@Override
				public Node makeInfixNode(Node left, Node right) {
					return n(n2d(left) * n2d(right));
				} 			
	 		},
	 		new Infix("/", 60) {
				@Override
				public Node makeInfixNode(Node left, Node right) {
					return n(n2d(left) / n2d(right));
				}
	 		},
			new Infix("%", 60) {
				@Override
				public Node makeInfixNode(Node left, Node right) {
					return n(n2d(left) % n2d(right));
				}
			},
			new Infix("^", 70, true) {
				@Override
				public Node makeInfixNode(Node left, Node right) {
					return n(Math.pow(n2d(left), n2d(right)));
				}
			},
			new Postfix("!", 80) {
				@Override
				public Node makePostfixNode(Node operand) {
					double n = n2d(operand), r = 1;
					while (n > 1) r *= n--;
					return n(r);
				}
			},
			new Prefix("@", 80) {
				@Override
				public Node makePrefixNode(Node operand) {
					return n((double) operand.hashCode());
				}
			}
		);
	}
	
}