/**
 * For copyright see license.txt.
 */
package anasy.examples.kalq2;

import anasy.SyntaxError;
import anasy.input.Input;
import anasy.syntax.special.Start;

public class Kalq2 {

	public static void main(String[] args) {
		System.out.println("Kalq 2 - calculator language");
		Input in = new Input();
		Start start = new Start(in, new Parser2().expr());
		MyNode tree = null;
		try {
			//String s = "fun f(n) is if n == 0 then 1 else n * f(n-1) end end; a=10; f(a)";
			String s = "fun f(n) is if n <= 2 then 1 else f(n-1) + f(n-2); a=10; f(a); prefix f 100";
			in.reset(s);
			tree = (MyNode) start.parse().value;
		} catch (SyntaxError e) {
			System.out.println(e);
			System.exit(0);
		}
		System.out.println("Tree: " + tree);

		// evaluate tree
		MyNode result = null;
		try {
			result = tree.eval();
		} catch (SemanticError e) {
			System.out.println(e);
			System.exit(0);
		}
		// print result
		System.out.println(result);
	}

}
