/**
 * For copyright see license.txt.
 */
package anasy.examples.kalq2;

import anasy.SyntaxError;
import anasy.Token;
import anasy.input.ReadlineInput;
import anasy.syntax.special.Start;

public class Kalq2i {

	public static void main(String[] args) {
		System.out.println("Kalq 2 - calculator language interactive interpreter");
		final ReadlineInput in = new ReadlineInput();
		Start start = new Start(in, new Parser2().expr()) {
			@Override
			public void ensure() throws SyntaxError {
				if (lexer.peek(tokBegin)) {
					in.refeed();			
				} else if (lexer.peek(tokEnd)) {
					in.refeed();
					lexer.advanceNext();
				}
			}
		};

		// std. library
		try {
			in.reset("fun fib(n) is if n <= 2 then 1 else fib(n-1) + fib(n-2)");
			((MyNode) start.parse().value).eval();
//			in.reset("prefix fib 100");
//			((MyNode) start.parse().value).eval();
			
		} catch (SemanticError e1) {
		} catch (SyntaxError e1) {
		}
		
		// REPL
		while (in.ready()) {
			Token tree;
			try {
				in.reset("");
				tree = start.parse();
				if (tree == null) continue;
			} catch (SyntaxError e) {
				System.out.println(e);
				continue;
			}
			MyNode node = (MyNode) tree.value;
			
			System.out.println("Tree: " + node);
			// evaluate tree
			MyNode result;
			try {
				result = node.eval();
			} catch (SemanticError e) {
				System.out.println(e);
				continue;
			}
			// print result
			System.out.println(result);
		}
	}

}
