package anasy;

import anasy.input.Location;

public class Token {

	public final Tokind kind;
	public final Location loc;
	public final Node value;

	public Token(Tokind kind, Location loc, Node value) {
		this.kind = kind;
		this.loc = loc;
		this.value = value;			
	}

	public Token(Tokind kind, Location loc) {
		this(kind, loc, null);
	}

	public Token(Token token) {
		this(token.kind, token.loc, token.value);
	}

    @Override
    public String toString() {
    	return kind.name + ((value != null) ? "(" + value + ")" : "");
    }

    public void error(String msg) throws SyntaxError {
    	throw new SyntaxError(msg, loc);
    }

    public String getName() {
		return kind.name;
	}
    
    public int getLbp() {
		return kind.lbp;
	}

    public boolean activate() {
		return kind.activate();
	}

	public Token parse(int rbp) throws SyntaxError {
		return kind.parse(rbp);
	}

	public Token parse(Token left, int rbp) throws SyntaxError {
		return kind.parse(left, rbp);
	}

}
