package anasy.input;

import anasy.SyntaxError;
import anasy.Token;
import anasy.Tokind;

public class Lexer {

	private final Tokind tokind;

	protected Token prev;
	protected Token next;

	public Lexer(Tokind tokind) {
		this.tokind = tokind;
	}

	public Token prev() {
		return prev;
	}

	public Token next() {
		return next;
	}
    
    public Token peek() {
    	return next();
    }

    public boolean peek(Tokind kind) {
    	return next.kind == kind;
    }

	public void begin(Token next) throws SyntaxError {
		this.next = next;
		next.activate();
 	    advance();
	}

	public void advanceNext() throws SyntaxError {
		do {
			next = tokind.lex();
		} while (!next.activate());		
	}
	
	public Token advance() throws SyntaxError {
		prev = next;
    	System.out.println("* " + prev);
		advanceNext();
		return prev;
	}

    public boolean advanceIf(Tokind kind) throws SyntaxError {
        if (peek(kind)) {
        	advance();
        	return true;
        } else
        	return false;
    }

    public void advance(Tokind kind) throws SyntaxError {
        if (!advanceIf(kind))
        	kind.error(next.loc, String.format("expected '%s', got '%s'", kind, next));
    }

}
