package anasy.input;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

public class ReadlineInput extends Input {

	public final String promptBegin;
	public final String promptCont;

	private BufferedReader reader;
	private int lineNo;
	
	public ReadlineInput(String promptBegin, String promptCont) {
		super();
		this.promptBegin = promptBegin;
		this.promptCont = promptCont;
		reader = new BufferedReader(new InputStreamReader(System.in));
	}

	public ReadlineInput() {
		this("> ", ". ");
	}
	
	private String readline() {
		try {
			System.out.print(lineNo == 0 ? promptBegin : promptCont);
			String line = reader.readLine();
			if (line != null) {
				lineNo++;
				return line;
			}
		} catch (IOException e) {}
		// if EOF(line == null) or exception
		reader = null;
		return null;
	}

	public boolean refeed() {
		if (reader == null) return false;
		String line = readline();
		if (line == null) return false;
	    append(line + "\n");
	    return true;
	}

	@Override
	public void reset(String str) {
		super.reset(str);
		lineNo = 0;
	}
	
	public boolean ready() {
		return available() > 0 || reader != null;
	}

}
