package anasy.syntax.literals;

import anasy.Node;
import anasy.Token;
import anasy.Tokind;
import anasy.input.Input;
import anasy.input.Location;

public abstract class Bool extends Literal {

	public Bool(String name) {
		super(name);
	}

	public Bool(Tokind parent) {
		this("<bool>");
	}

	protected abstract Node makeNode(boolean val);

	@Override
	public Token lex() {
		final Input in = getInput();
		final Location loc = in.getLoc();
        if (in.advanceIf("true"))
        	return new Token(this, loc, makeNode(true));
        if (in.advanceIf("false"))
        	return new Token(this, loc, makeNode(false));
        return null;
	}

}
