/**
 * For copyright see license.txt.
 */
package anasy.syntax.literals;

import anasy.Node;
import anasy.SyntaxError;
import anasy.Token;
import anasy.Tokind;
import anasy.input.Input;
import anasy.input.Location;


/**
 * Decimal integer numbers.
 * @author jure
 */
public abstract class IntNum extends Literal {

	public IntNum(String name) {
		super(name);
	}

	public IntNum(Tokind parent) {
		this("<int>");
	}

	protected abstract Node makeNode(String lexeme);

	@Override
	public Token lex() throws SyntaxError {
		final Input in = getInput();
		// digits
		if (!Character.isDigit(in.peek())) return null;
		final Location loc = in.getLoc();
		in.advanceDigits(10);
		if (Character.isLetterOrDigit(in.peek()))
			throw new SyntaxError(String.format("Invalid digit '%c'", in.peek()), in.getLoc());
		return new Token(this, loc, makeNode(in.extract(loc)));
	}

}
