/**
 * For copyright see license.txt.
 */
package anasy.syntax.literals;

import anasy.Node;
import anasy.Token;
import anasy.input.Input;
import anasy.input.Location;


/**
 * Names -- identifiers -- start with a letter or underscore.
 * @author jure
 */
public abstract class Name extends Literal {

	public Name(String name) {
		super(name);
	}

	public Name() {
		this("<name>");
	}

	@Override
	public int rp() {
		return 100;
	}

	protected abstract Node makeNode(String lexeme);

	@Override
	public Token lex() {
		final Input in = getInput();
		if (!Character.isLetter(in.peek()) && in.peek() != '_')
			return null;
		final Location loc = in.getLoc();
		while (Character.isLetterOrDigit(in.peek()) || in.peek() == '_')
			in.advance();
		return new Token(this, loc, makeNode(in.extract(loc)));
	}
	
}
