/**
 * For copyright see license.txt.
 */
package anasy.syntax.operators;

import anasy.Node;
import anasy.SyntaxError;
import anasy.Token;
import anasy.input.Lexer;

/**
 * Infix operators.
 * @author jure
 *
 * @param <N>
 */
public abstract class Infix extends Operator {

	public final boolean rightAssoc;

	public Infix(String name, int lbp, boolean rightAssoc) {
		super(name, lbp);
		this.rightAssoc = rightAssoc;
	}

	public Infix(String name, int lbp) {
		this(name, lbp, false);
	}

	protected abstract Node makeInfixNode(Node left, Node right);

	@Override
	public Token parse(Token left, int rbp) throws SyntaxError {
		final Lexer lexer = getLexer();
		final Token right = parent.parse(rightAssoc ? lbp - 1: lbp);
		return new Token(parent, lexer.prev().loc, makeInfixNode(left.value, right.value));
	}

}