/**
 * For copyright see license.txt.
 */
package anasy.syntax.operators;

import anasy.SyntaxError;
import anasy.Token;
import anasy.Tokind;
import anasy.input.Input;
import anasy.input.Location;


/**
 * Base class for operators: punctuation or keyword.
 * @author jure
 */
public class Operator extends Tokind {

	public Operator(String name, int lbp) {
		super(name, lbp);
	}

	@Override
	public Token lex() throws SyntaxError {
		final Input in = getInput();
		final Location loc = in.getLoc();
        return in.advanceIf(name) ? new Token(this, loc) : null;
	}

}


/*private boolean isPunctuation;

	public static <N> Tokind<N> make(Parser<N> parser, String lexeme, int lbp) {
		Tokind<N> kind = parser.find(lexeme);
		if (kind == null) return new Operator<N>(parser, lexeme, lbp);
		if (kind.lbp() == lbp) return kind;
		return null; //TODO: exception
	}

	protected boolean isKeyword(String lexeme) {
		if (lexeme.length() <= 0) return false;
		char first = lexeme.charAt(0);
		if (!Character.isLetter(first) && first != '_') return false;
		for (char ch: lexeme.toCharArray())
			if (!Character.isLetterOrDigit(ch) && ch != '_') return false;
		return true;
	}
	
	public Operator(Parser<N> parser, String name, int lbp) {
		super(parser, name, lbp);
		this.isPunctuation = !isKeyword(name); 
	}

	@Override
	public Token<N> lex() throws SyntaxError {
		Location lexloc = input.mark();
		if (input.advanceIf(name) && (isPunctuation || !Character.isLetterOrDigit(input.peek())))
			return new Token<N>(this, lexloc);
		input.setLoc(lexloc);
		return null;
	}

}
*/