/**
 * For copyright see license.txt.
 */
package anasy.syntax.operators;

import anasy.Node;
import anasy.SyntaxError;
import anasy.Token;


/**
 * Postfix operators.
 * @author jure
 */
public abstract class Postfix extends Operator {

	public Postfix(String name, int lbp) {
		super(name, lbp);
	}

	public abstract Node makePostfixNode(Node operand);
	
	@Override
	public Token parse(Token left, int rbp) throws SyntaxError {
		return new Token(parent, left.loc, makePostfixNode(left.value));
	}

}