/**
 * For copyright see license.txt.
 */
package anasy.syntax.operators;

import anasy.Node;
import anasy.SyntaxError;
import anasy.Token;
import anasy.input.Lexer;


/**
 * Prefix operators.
 * @author jure
 */
public abstract class Prefix extends Operator {

	public final int pbp;	// prefix bounding precedence

	public Prefix(String name, int pbp) {
		super(name, 0);
		this.pbp = pbp;
	}

	public abstract Node makePrefixNode(Node operand);

	@Override
	public Token parse(int rbp) throws SyntaxError {
		final Lexer lexer = getLexer();
		final Node right = parent.parse(pbp).value;
		return new Token(parent, lexer.prev().loc, makePrefixNode(right));
	}	

}
