/**
 * For copyright see license.txt.
 */
package anasy.syntax.operators;

import anasy.Node;
import anasy.SyntaxError;
import anasy.Token;
import anasy.input.Lexer;


/**
 * Prefix and postfix operators.
 * @author jure
 */
public abstract class PrefixPostfix extends Operator {

	public final int pbp;

	public PrefixPostfix(String name, int pbp, int lbp) {
		super(name, lbp);
		this.pbp = pbp;
	}

	public abstract Node makePrefixNode(Node operand);

	public abstract Node makePostfixNode(Node operand);

	@Override
	public Token parse(int rbp) throws SyntaxError {
		final Lexer lexer = getLexer();
		final Node right = parent.parse(pbp).value;
		return new Token(parent, lexer.prev().loc, makePrefixNode(right));
	}

	@Override
	public Token parse(Token left, int rbp) throws SyntaxError {
		return new Token(parent, left.loc, makePostfixNode(left.value));
	}

}