package anasy.syntax.special;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

import anasy.SyntaxError;
import anasy.Token;
import anasy.Tokind;


public abstract class Tokinds extends Tokind {

	private final List<Tokind> tokinds = new ArrayList<Tokind>();

	public Tokinds(String name, int lbp, Tokind... tokinds) {
		super(name, lbp);
		add(tokinds);
	}

	public void add(Tokind tokind) {
		tokind.setParent(this);
		tokinds.add(tokind);
		Collections.sort(tokinds, new Comparator<Tokind>() {
			@Override
			public int compare(Tokind o1, Tokind o2) {
				if (o1.rp() != o2.rp())
					return o1.rp() - o2.rp();
				else
					return o2.name.length() - o1.name.length();
			}
		});
	}

	@Override
	public Token lex() throws SyntaxError {
		for (Tokind tokind: tokinds) {
			Token t = tokind.lex();
			if (t != null) return t;
		}
		return null;
	}

}
