/**
 * For copyright see license.txt.
 */
package anasy.syntax.whitespace;

import anasy.SyntaxError;
import anasy.Token;
import anasy.Tokind;
import anasy.input.Input;
import anasy.input.Location;

/**
 * Inline comments. Comment begins with a name.
 * @author jure
 */
public class InlineComment extends Tokind {

	public InlineComment(String name) {
		super(name, 0);
	}

	@Override
	public Token lex() throws SyntaxError {
		final Input in = getInput();
		final Location loc = in.getLoc();
		if (!in.advanceIf(name)) return null;
		while (in.available() > 0 && in.peek() != '\n') in.advance();
		return new Token(this, loc);
	}

	@Override
	public boolean activate() {
		return false;
	}
}
