/**
 * For copyright see license.txt.
 */
package anasy.syntax.whitespace;

import anasy.SyntaxError;
import anasy.Token;
import anasy.Tokind;
import anasy.input.Input;
import anasy.input.Location;

/**
 * Whitespace skipper. " \t\n". See Character.isWhitespace().
 * @author jure
 */
public class Whitespace extends Tokind {

	public Whitespace(String name) {
		super(name, 0);
	}

	public Whitespace() {
		this("<whitespace>");
	}

	@Override
	public Token lex() throws SyntaxError {
		final Input in = getInput();
		if (!Character.isWhitespace(in.peek())) return null;
		final Location loc = in.getLoc();
		while (Character.isWhitespace(in.peek())) in.advance();
		return new Token(this, loc);
	}

	@Override
	public boolean activate() {
		return false;
	}
}